package itz;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class UsaEjecutor {
	public static void main(String args[]) {
		/*La parte ms importante es Executors.newFixedThreadPool(5). 
		 * Con esto estamos definiendo un contenedor de un tamao mximo de 5 espacios. 
		 * En estos espacios se insertaran hilos y se ejecutarn. 
		 * Cuando uno de ellos termine su ejecucin, 
		 * se sacar el hilo de ese espacio y se insertara otro de los que este en la cola.*/
		ExecutorService exec = Executors.newFixedThreadPool(5);
		
		for (int i = 0; i < 1000; i++) {
			exec.execute(new Runnable() {
				public void run() {
					System.out.println(" Ejecutandose en: " + Thread.currentThread());
				}
			});
		}
		/*Despus de crear 100 hilos y ordenar que se ejecuten, 
		 * invocamos al mtodo shutdown() de la Thread Pool. 
		 * Con esta llamada indicamos que, una vez se hayan ejecutado todos los hilos, 
		 * se habr terminado la funcin run.*/
		exec.shutdown();
		/*El mtodo awaitTermination detiene la ejecucin del programa 
		 * hasta que haya acabado todo el trabajo o hasta que se sobrepase 
		 * el nmero de segundos de espera que se pasan como argumento*/
		try {
			boolean b = exec.awaitTermination(100, TimeUnit.MILLISECONDS);
			System.out.println("Terminarn todos los hilos: " + b);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
		


